#include <iostream>
#include <algorithm>

using namespace std;

int main()
{
    int t;
    scanf("%d", &t);
    int n, k;
    scanf("%d %d", &n, &k);
    int l[n];
    for (int i=0; i<n; i++) scanf("%d", &l[i]);
    sort(l, l+n);

    // sim
    int a=0;
    int sgn[n];
    for (int i=0; i<n; i++) {
        if (a > l[i]) {
            a--;
            sgn[i] = -1;
        } else {
            a++;
            sgn[i] = 1;
        }
    }

    if (a < k) printf("NE");
    else {
        if (a == k) {
            printf("DA\n");
            if (t == 1) {
                for (auto el : l)
                    printf("%d ", el);
            }
        }
        else {
            int r = a-k;
            int c = 0;
            for (int i=0; i<n; i++) {
                if (sgn[i] == 1 && l[i] < a) c++;
            }
            if (c != 0) {
                printf("DA");
            } else printf("NE");
        }

    }

    return 0;
}